

var isMSIE = navigator.appName == 'Microsoft Internet Explorer',
	lastClickTime = 0,
	currentDragLayer = null,
    currentDragLastX,
    currentTurnAngle = 0,
    isTurning = false;

function getElementPosition( element ) {
	var x = -document.body.scrollLeft,
	    y = -document.body.scrollTop;
	    
	while( element && element != document.body ) {
		x += element.offsetLeft;
		y += element.offsetTop;
		element = element.parentNode
	}
	
	return { 'x' : x, 'y' : y };
}

function contains( element, x, y ) {
	var position = getElementPosition( element );
	    
	return x >= position.x && x < position.x + element.offsetWidth &&
	       y >= position.y && y < position.y + element.offsetHeight;
}

function handleMouseDown( eventData ) {
	if( isMSIE )
		eventData = event;
		
	var x = eventData.clientX,
	    y = eventData.clientY,
	    button = eventData.button;
	    
	if( isTurning )
		return;
	
	if( button == ( isMSIE ? 1 : 0 ) ) {
		var layer;
		
		if( contains( layer = document.getElementById( 'upperSliderLayer' ), x, y ) ||
		    contains( layer = document.getElementById( 'lowerSliderLayer' ), x, y ) ) {
			currentDragLayer = layer;
			currentDragLastX = x;
		}
	}
}

function handleMouseMove( eventData ) {
	if( isMSIE )
		eventData = event;
		
	var x = eventData.clientX,
	    y = eventData.clientY;
	    
	if( isTurning )
		return;
	    
	if( currentDragLayer ) {
		var layerX = ( parseInt( currentDragLayer.style.left ) || 0 ) + x - currentDragLastX;
		currentDragLayer.style.left = ( layerX < -770 ? -770 : ( layerX > 770 ? 770 : layerX ) ) + 'px';
		currentDragLastX = x;                          
	}
}

function handleMouseUp( eventData ) {
	if( isMSIE )
		eventData = event;
		
	var x = eventData.clientX,
	    y = eventData.clientY,
	    now = ( new Date() ).getTime();
		
	currentDragLayer = null;
	
	if( !isTurning && now - lastClickTime < 250 && contains( document.getElementById( 'envelopeLayer' ), x, y ) )
		startTurn();
		
	lastClickTime = now;
}

function startTurn() {
	isTurning = true;
	
	document.getElementById( 'envelopeImage' ).style.display = 'block';
	document.getElementById( 'upperSliderImage' ).style.display = 'block';
	document.getElementById( 'lowerSliderImage' ).style.display = 'block';
	
	document.getElementById( 'envelopeLayer' ).style.backgroundImage = 'none';
	document.getElementById( 'upperSliderLayer' ).style.backgroundImage = 'none';
	document.getElementById( 'lowerSliderLayer' ).style.backgroundImage = 'none';
	
	doTurn( currentTurnAngle ? -15 : 15 );
}

function doTurn( angle ) {
	currentTurnAngle += angle;
	
	var layer,
	    axis = 324 / 2;
	    theta = currentTurnAngle * Math.PI / 180,
	    scale = Math.abs( Math.cos( theta ) ),
	    upperOffset = axis - 138 * scale,
	    lowerOffset = axis + 10 * scale;
	    
	var backgroundLayer = document.getElementById( 'backgroundLayer' ),
		envelopeLayer = document.getElementById( 'envelopeLayer' ),
	    upperSliderLayer = document.getElementById( 'upperSliderLayer' ),
	    lowerSliderLayer = document.getElementById( 'lowerSliderLayer' )
	
	backgroundLayer.style.top = parseInt( axis - 152 * scale ) + 'px';
	envelopeLayer.style.top = parseInt( axis - 162 * scale ) + 'px';
	upperSliderLayer.style.top = parseInt( currentTurnAngle < 90 ? upperOffset : lowerOffset ) + 'px';
	lowerSliderLayer.style.top = parseInt( currentTurnAngle > 90 ? upperOffset : lowerOffset ) + 'px';
	    
	backgroundLayer.style.height = parseInt( 304 * scale ) + 'px';
	envelopeLayer.style.height = parseInt( 324 * scale ) + 'px';
	upperSliderLayer.style.height = parseInt( 126 * scale ) + 'px';
	lowerSliderLayer.style.height = parseInt( 126 * scale ) + 'px';
	
	document.getElementById( 'envelopeImage' ).style.height = parseInt( 324 * scale ) + 'px';
	document.getElementById( 'upperSliderImage' ).style.height = parseInt( 126 * scale ) + 'px';
	document.getElementById( 'lowerSliderImage' ).style.height = parseInt( 126 * scale ) + 'px';
	
	if( currentTurnAngle == 90 ) {
		if( angle > 0 ) {
			document.getElementById( 'envelopeImage' ).src = 'envelope-back.png';
			document.getElementById( 'upperSliderImage' ).src = 'upper-slider-back.png';
			document.getElementById( 'lowerSliderImage' ).src = 'lower-slider-back.png';
		}
		else {
			document.getElementById( 'envelopeImage' ).src = 'envelope-front.png';
			document.getElementById( 'upperSliderImage' ).src = 'upper-slider-front.png';
			document.getElementById( 'lowerSliderImage' ).src = 'lower-slider-front.png';
		}
	}
	
	if( 0 < currentTurnAngle && currentTurnAngle < 180 )
		setTimeout( 'doTurn(' + angle + ');', 100 );
	else {
		document.getElementById( 'envelopeImage' ).style.display = 'none';
		document.getElementById( 'upperSliderImage' ).style.display = 'none';
		document.getElementById( 'lowerSliderImage' ).style.display = 'none';
		
		if( currentTurnAngle ) {
			document.getElementById( 'envelopeLayer' ).style.backgroundImage = 'url("envelope-back.png")';
			document.getElementById( 'upperSliderLayer' ).style.backgroundImage = 'url("upper-slider-back.png")';
			document.getElementById( 'lowerSliderLayer' ).style.backgroundImage = 'url("lower-slider-back.png")';
		}
		else {
			document.getElementById( 'envelopeLayer' ).style.backgroundImage = 'url("envelope-front.png")';
			document.getElementById( 'upperSliderLayer' ).style.backgroundImage = 'url("upper-slider-front.png")';
			document.getElementById( 'lowerSliderLayer' ).style.backgroundImage = 'url("lower-slider-front.png")';
		}
		isTurning = false;
	}
}

function handleResize() {
	var mainLayer = document.getElementById( 'mainLayer' );
	
	mainLayer.style.left = ( document.body.offsetWidth - 800 ) / 2 + 'px';
	mainLayer.style.top = ( document.body.offsetHeight - 324 ) / 2 + 'px';
}

onload = function() {
	( onresize = handleResize )();
	document.onselectstart = function() { return false; }
	document.onmousedown = handleMouseDown;
	document.onmousemove = handleMouseMove;
	document.onmouseup = handleMouseUp;
	
	var element;
	( element = document.getElementById( 'envelopeImageDummy' ) ).parentNode.removeChild( element );
	( element = document.getElementById( 'upperSliderImageDummy' ) ).parentNode.removeChild( element );
	( element = document.getElementById( 'lowerSliderImageDummy' ) ).parentNode.removeChild( element );
	( element = document.getElementById( 'standByLabel' ) ).parentNode.removeChild( element );
	
	document.getElementById( 'mainLayer' ).style.display = '';
}